<?php
/**
* COMPONENT FILE HEADER
**/
namespace G2\A\E\Chronoconnectivity\C;
/* @copyright:ChronoEngine.com @license:GPLv2 */defined('_JEXEC') or die('Restricted access');
defined("GCORE_SITE") or die;
class Manager extends \G2\L\Controller {
	var $models = array('\G2\A\E\Chronoconnectivity\M\Connection');
	
	var $helpers= array(
		'\G2\A\E\Chronofc\H\Parser',
		'\G2\A\E\Chronofc\H\Field',
		'\G2\H\Html',
		'\G2\H\Sorter',
		'\G2\H\Paginator',
	);
	
	function _initialize(){
		//$this->layout('default');
		$this->fparams = \GApp::extension('chronoconnectivity')->settings();
	}
	
	function index(){
		$conn = $this->get('conn', $this->data('conn'));
		
		if(empty($conn)){
			return ['error' => rl('Error, connection does not exist.')];
		}
		
		$connection = $this->Connection->where('alias', $conn, '= BINARY')->where('published', 1)->order(['id' => 'desc'])->select('first', ['json' => ['events', 'views', 'functions', 'plugins', 'locales', 'rules', 'params']]);
		
		if(empty($connection)){
			return ['error' => rl('Error, connection does not exist or is not published.')];
		}
		
		if(empty($connection['Connection']['public']) AND $this->site == 'front'){
			return ['error' => rl('Error, connection is not available for frontend users.')];
		}
		
		$rules = array_filter($connection['Connection']['rules']['access']);
		if(!empty($rules) AND \GApp::access($connection['Connection']['rules'], 'access') !== true){
			return ['error' => rl('You do not have enough permissions to access this resource.')];
		}
		
		$this->set('__connection', $connection['Connection']);
		
		$event = $this->get('event', $this->data('event'));
		
		if(empty($event)){
			if(!empty($connection['Connection']['params']['default_event'])){
				$event = $connection['Connection']['params']['default_event'];
			}else{
				$event = 'index';
			}
		}
		
		$this->set('__event', $event);
		
		if(class_exists('\G2\A\E\Chronoforms\M\Block')){
			//find if blocks are needed
			$this->Block = new \G2\A\E\Chronoforms\M\Block();
			$view_blocks = \G2\L\Arr::getVal($connection, 'Connection.views.[n].type', []);
			$fn_blocks = \G2\L\Arr::getVal($connection, 'Connection.functions.[n].type', []);
			$blocks_ids = [];
			foreach($view_blocks as $k => $view_block){
				if($view_block == 'stored_block'){
					$blocks_ids[] = $connection['Connection']['views'][$k]['id'];
				}
			}
			
			foreach($fn_blocks as $k => $fn_block){
				if($fn_block == 'stored_block'){
					$blocks_ids[] = $connection['Connection']['functions'][$k]['id'];
				}
			}
			
			$blocks_ids = array_unique($blocks_ids);
			
			$blocks = [];
			if(!empty($blocks_ids)){
				$blocks = $this->Block->where('id', $blocks_ids, 'in')->select('all', ['json' => ['content']]);
			}
			
			$this->set('__blocks', $blocks);
		}
		
		if(\GApp::instance()->site == 'front'){
			$good = (\GApp::extension('chronoconnectivity')->valid() OR !isset($connection['Connection']['params']['limited_edition']));
			if(!$good){
				$this->set('__viewslimit', 10);
			}
		}
		
		$this->view = [
			'views' => [
				'site' => 'admin',
				'cont' => 'manager',
				'act' => 'event',
			]
		];
	}
	
	function _finalize(){
		if(empty($this->tvout) AND \GApp::extension('chronoconnectivity')->valid() == false){
			echo '<a href="http://www.chronoengine.com/" target="_blank">Powered by ChronoConnectivity 6 - ChronoEngine.com</a>';
		}
	}
}
?>