<?php
/* @copyright:ChronoEngine.com @license:GPLv2 */defined('_JEXEC') or die('Restricted access');
defined("GCORE_SITE") or die;
?>

<form action="<?php echo r2('index.php?ext=chronoconnectivity&cont=connections'); ?>" method="post" name="admin_form" id="admin_form" class="ui form">
	
	<h2 class="ui header"><?php el('Connections manager'); ?></h2>
	<div class="ui">
		<div class="ui labeled icon dropdown button blue compact pointing">
			<i class="plus icon"></i>
			<span class="text"><?php el('New'); ?></span>
			<div class="menu">
				<a class="item" href="<?php echo r2('index.php?ext=chronoconnectivity&cont=connections&act=demos'); ?>">
					<?php el('Empty connection'); ?>
				</a>
			</div>
		</div>
		<div class="ui labeled icon dropdown button green compact pointing">
			<i class="plus icon"></i>
			<span class="text"><?php el('Demos'); ?></span>
			<div class="menu">
				<a class="item" href="<?php echo r2('index.php?ext=chronoconnectivity&cont=connections&act=demos&name=articles1'); ?>">
					<?php el('Basic articles list'); ?>
				</a>
				<a class="item" href="<?php echo r2('index.php?ext=chronoconnectivity&cont=connections&act=demos&name=articles2'); ?>">
					<?php el('Dynamic actions'); ?>
				</a>
				<a class="item" href="<?php echo r2('index.php?ext=chronoconnectivity&cont=connections&act=demos&name=articles3'); ?>">
					<?php el('Articles relations'); ?>
				</a>
				<a class="item" href="<?php echo r2('index.php?ext=chronoconnectivity&cont=connections&act=demos&name=articles4'); ?>">
					<?php el('Custom articles listing'); ?>
				</a>
			</div>
		</div>
		<button type="button" class="compact ui button red icon labeled toolbar-button" data-url="<?php echo r2('index.php?ext=chronoconnectivity&cont=connections&act=delete'); ?>">
			<i class="trash icon"></i><?php el('Delete'); ?>
		</button>
		<button type="button" class="compact ui button teal icon labeled toolbar-button" data-url="<?php echo r2('index.php?ext=chronoconnectivity&cont=connections&act=copy'); ?>">
			<i class="copy icon"></i><?php el('Copy'); ?>
		</button>
		<button type="button" class="compact ui button orange icon labeled toolbar-button" data-url="<?php echo r2('index.php?ext=chronoconnectivity&cont=connections&act=backup'); ?>">
			<i class="download icon"></i><?php el('Backup'); ?>
		</button>
		<a class="compact ui button blue icon labeled toolbar-button" href="<?php echo r2('index.php?ext=chronoconnectivity&cont=connections&act=restore'); ?>">
			<i class="upload icon"></i><?php el('Restore'); ?>
		</a>
		<a class="compact ui button purple icon labeled toolbar-button" href="<?php echo r2('index.php?ext=chronoconnectivity&cont=tables&act=build'); ?>">
			<i class="database icon"></i><?php el('Create table'); ?>
		</a>
	</div>
	
	<div class="ui clearing divider"></div>
	
	<table class="ui selectable table">
		<thead>
			<tr>
				<th class="">
					<div class="ui select_all checkbox">
						<input type="checkbox">
						<label></label>
					</div>
				</th>
				<th class="single line"><?php echo $this->Sorter->link(rl('ID'), 'connection_id'); ?></th>
				<th class=""><?php echo $this->Sorter->link(rl('Title'), 'connection_title'); ?></th>
				<th class=""><?php el('Alias'); ?></th>
				<th class="five wide"><?php el('Description'); ?></th>
				<th class="single line"><?php el('Data tables'); ?></th>
				<th class="single line"><?php echo $this->Sorter->link(rl('Public'), 'connection_public'); ?></th>
				<th class="single line"><?php echo $this->Sorter->link(rl('Published'), 'connection_published'); ?></th>
				<th class=""><?php el('Display'); ?></th>
			</tr>
		</thead>
		<tbody>
			<?php foreach($connections as $i => $connection): ?>
			<tr>
				<td class="collapsing">
					<div class="ui checkbox selector">
						<input type="checkbox" class="hidden" name="gcb[]" value="<?php echo $connection['Connection']['id']; ?>">
						<label></label>
					</div>
				</td>
				<td class="collapsing"><?php echo $connection['Connection']['id']; ?></td>
				<td><?php echo $this->Html->attr('href', r2('index.php?ext=chronoconnectivity&cont=connections&act=edit'.rp('id', $connection['Connection'])))->content($connection['Connection']['title'])->tag('a'); ?></td>
				<td><?php echo $connection['Connection']['alias']; ?></td>
				<td><?php echo $connection['Connection']['description']; ?></td>
				<td><?php $this->view('views.connections.connected_tables', ['connection' => $connection]); ?></td>
				<td>
					<?php
						echo $this->Html
						->attr('href', r2('index.php?ext=chronoconnectivity&cont=connections&act=toggle'.rp('gcb', $connection['Connection']['id']).rp('fld', 'public').rp('val', (int)!(bool)$connection['Connection']['public'])))
						->addClass('compact ui button icon mini circular '.((int)$connection['Connection']['public'] ? 'green' : 'red'))
						->content('<i class="icon '.((int)$connection['Connection']['public'] ? 'check' : 'cancel').'"></i>')
						->tag('a');
					?>
				</td>
				<td>
					<?php
						echo $this->Html
						->attr('href', r2('index.php?ext=chronoconnectivity&cont=connections&act=toggle'.rp('gcb', $connection['Connection']['id']).rp('fld', 'published').rp('val', (int)!(bool)$connection['Connection']['published'])))
						->addClass('compact ui button icon mini circular '.((int)$connection['Connection']['published'] ? 'green' : 'red'))
						->content('<i class="icon '.((int)$connection['Connection']['published'] ? 'check' : 'cancel').'"></i>')
						->tag('a');
					?>
				</td>
				<td><?php echo $this->Html->attr('href', r2('index.php?ext=chronoconnectivity&cont=manager'.rp('conn', $connection['Connection']['alias'])))->attr('target', '_blank')->content(rl('Open'))->tag('a'); ?></td>
			</tr>
			<?php endforeach; ?>
		</tbody>
		<tfoot>
			<tr>
				<th colspan="9">
				<?php echo $this->Paginator->navigation('Connection'); ?>
				<?php echo $this->Paginator->limiter('Connection'); ?>
				</th>
			</tr>
		</tfoot>
	</table>
	
</form>
